/*
Konyhakerti novenyekrol haromfele informaciot tudunk:
	A szereti, ha B mellett van
	A-t vedi B
	A ellensege B-nek
Mind harom szabaly szimetrikus. Keszits Prolog szabalyt,
amely megadja, hogy milyen sorrendbe vessuk el oket,
hogy vgl Na db sor A, Nb db sor B, Nc db sor C ... legyen.
A sorrend a fenti informaciok alapjan a leheto legjobb legyen.
*/

Domains
	elem = symbol
	lista = elem*

Predicates
	a(elem) % harom csoportba soroljuk a novenyeket
	b(elem)
	c(elem)
	sor(elem,integer)
	
	ellenseg(elem,elem)	
	vedi(elem,elem)
	szereti(elem,elem)

	noveny(elem)    	% alaphalmaz	
	ellen(elem,elem)	% szimetrikus ellenseg
	ved(elem,elem)		% szimetrikus vedi
	szeret(elem,elem)	%szimetrikus szereti
	
	kedvezo(elem,elem)
	szomszed(elem,elem)

	jo(lista,integer)
	ajo(lista,integer)
	bjo(lista,integer)
	cjo(lista,integer)

	kellmeg(elem,lista)
	megszamol(elem,lista,integer)

Clauses

a(paradicsom).
a(brokkoli).
a(kellbimbo).

b(bab).
b(patiszon).
b(karfiol).

c(sargarepa).
c(borso).
c(retek).

sor(paradicsom, 2).
sor(brokkoli, 1).
sor(kellbimbo, 2).
sor(bab, 1).
sor(patiszon, 2).
sor(karfiol, 1).
sor(sargarepa, 1).
sor(retek, 2).


ellenseg(paradicsom, borso).
%ellenseg().
%ellenseg().

vedi(paradicsom, borso).
%vedi().
%vedi().

szereti(paradicsom, bab).
%szereti().
%szereti().

% =============================================== %

noveny(X) if a(X) or b(X) or c(X).
% noveny(X) if sor(X,_).

ellen(X,Y) if ellenseg(X,Y) or ellenseg(Y,X).
ved(X,Y) if vedi(X,Y) or vedi(Y,X).
szeret(X,Y) if szereti(X,Y) or szereti(Y,X).

kedvezo(X,Y) if ved(X,Y) or szeret(X,Y).

szomszed(X,Y) if kedvezo(X,Y) or noveny(X) and not(ellen(X,Y)).

jo([],0) if !.
jo([X], 1) if c(X).
jo([X|Y], K) if Z=K-1 and bjo(Y,Z) 
                and Y=[P|_] and c(X) 
                and szomszed(X,P)
	 	and kellmeg(X,Y).

ajo([X], 1) if a(X).
ajo([X|Y], K) if Z=K-1 and jo(Y,Z) 
                and Y=[P|_] and a(X) 
                and szomszed(X,P)
	 	and kellmeg(X,Y).

bjo([X], 1) if b(X).
bjo([X|Y], K) if Z=K-1 and cjo(Y,Z) 
                and Y=[P|_] and b(X) 
                and szomszed(X,P)
	 	and kellmeg(X,Y).

cjo([X], 1) if c(X).
cjo([X|Y], K) if Z=K-1 and ajo(Y,Z) 
                and Y=[P|_] and c(X) 
                and szomszed(X,P)
	 	and kellmeg(X,Y).

kellmeg(X,Y) if megszamol(X,Y,DB) and sor(X,K) and DB<K.

megszamol(_,[],0) if !.
megszamol(X,[X|Y],DB) if megszamol(X,Y,DB0) and DB=DB0+1 and !.
megszamol(X,[_|Y],DB) if megszamol(X,Y,DB) and !.