/*
 Az egyetem tanar szakjaira felvett hallgatok letszamat 
 az alabbi alaku tenyekkel adjuk meg:
 felvett(szak1, szak2, letszam).
 Figyelem! 
 A fizika, matek szak klnbzik a matek, fizika szaktl,
 mert az els a fszak, a msodik az alszak.

 Irjon PROLOG szabalyokat, amelyek megadjak, hogy
 A, Melyik az a szak, amely minden ms szakkal prostva felvehet, fggetlenl attl,
    hogy f vagy alszak.
 B, Van-e kt olyan szak (s ha van, akkor melyik),
    amik csak els szakknt vehetk fel s
    pont ugyanazokkal a msodik szakokkal parosithatok?
 C, Melyik szakra hny hallgatt vettek fel? 
    (Ennek a feladatnak a megoldasahoz hasznaljon adatbazist!)
 D, Egy adott szakhoz allitsa elo azt a listat, amiben a vele parban felveheto szakok talalhatok!
 (Szabalyt barmilyet felvehet, de teny csak a felvett(szak1, szak2, letszam) lehet.)
      

*/
/*trace*/
domains
	szak=symbol
	letszam=integer
	db=integer
	szakok=szak*

database
	szak(szak)	/*az elofordulo szakok*/
	mar_szamolt_szak(szak) /*az a feladat masodik megoldasahoz*/
	mar_regisztralt_alszak(szak) /*a b feladathoz*/
	mar_szamolt_letszam(szak,szak) /*a c feladathoz*/
	mar_regisztralt_szakpar(szak) /*a d feladathoz*/
	
predicates
	felvett(szak,szak,letszam)
	/*szakok adatbazisban valo eltarolasa*/
		letezofoszakok
		letezoalszakok
		letezoszakok

	/*az a feladathoz szukseges szabalyok*/
	  /*megoldas tagadassal*/
		mindennel(szak)
		nemmindennel(szak)
		afeladat_mo1
	  /*megoldas db szamok segitsegevel*/
		szakdb(db)
		szakpardb(szak,db)
		joszak(szak,db)
		vanjoszak
		afeladat_mo2
		
	/*a b feladathoz szukseges szabalyok*/
		csakfoszak(szak)
		alszakok(szak,szakok)
		eleme(szak,szakok)
		metszet(szakok,szakok,szakok)
		azonos(szakok,szakok)
		azonosalszakok(szak,szak)
		joszakok(szak,szak)
		bfeladat

	/*a c feladathoz szukseges szabalyok*/
		foszak_letszam(szak,letszam)
		alszak_letszam(szak,letszam)
		letszam(szak,letszam)
		letszamok
		cfeladat

	/*a d feladathoz szukseges szabalyok*/
		szakpar(szak,szak)
		szakparok(szak,szakok)
		kiirlista(szakok)
		dfeladat
	
clauses
	/*tenyek*/
	felvett(cseh,fizika,10).
	felvett(biologia,nemet,50).
	felvett(magyar,fizika,20).
	felvett(fizika,nemet,100).
	felvett(fizika,japan,10).
	felvett(fizika,angol,12).
	felvett(biologia,fizika,30).
	felvett(nemet,biologia,10).
	felvett(cseh,biologia,32).
	
	/*a szakok tarolasa adatbazisban*/
       		letezofoszakok if 
       			felvett(Szak,_,_) and 
	       		not(szak(Szak)) and
       			assert(szak(Szak)) and 
       			fail or true.        		
	       	letezoalszakok if
       			felvett(_,Szak,_) and 
       			not(szak(Szak)) and
	       		assert(szak(Szak)) and 
	       		fail or true.        		
       		letezoszakok if
       			retractall(szak(_)) and
	       		letezofoszakok and letezoalszakok.	

	/*az a feladathoz szukseges szabalyok*/

	  /*megoldas tagadassal*/
                nemmindennel(Szak) if 
                	szak(Masikszak) and Masikszak<>Szak and 
                	not(szakpar(Szak,Masikszak)).
                mindennel(Szak) if 
                	szak(Szak) and not(nemmindennel(Szak)).
                afeladat_mo1 if 
	                nl and write("A feladat:") and nl and
                	mindennel(Szak) and write(Szak) or 
                	write("Nincs ilyen szak!").

          /*megoldas db szamok segitsegevel*/ 
		szakdb(Db) if
			szak(Szak) and
			not(mar_szamolt_szak(Szak)) and
			assert(mar_szamolt_szak(Szak)) and
			szakdb(Db_maradek) and
			Db=Db_maradek+1 or
			Db=0.
		szakpardb(Szak,Db) if
			szakpar(Szak,Szakpar) and	
			not(mar_szamolt_szak(Szakpar)) and
			assert(mar_szamolt_szak(Szakpar)) and
			szakpardb(Szak,Db_maradek) and
			Db=Db_maradek+1 or
			Db=0.
		joszak(Szak,Szakdb) if
			retractall(mar_szamolt_szak(_)) and
			szakpardb(Szak,Db) and ! and Db=Szakdb-1.			
        	vanjoszak if
        		retractall(mar_szamolt_szak(_)) and szakdb(SzakDb) and
        		! and
        		szak(Szak) and joszak(Szak,SzakDb) and write(Szak). 
                afeladat_mo2 if 
                	nl and write("A feladat:") and nl and
                	vanjoszak or write("Nincs ilyen szak!").        			
                       			
	/*a b feladathoz szukseges szabalyok*/

		csakfoszak(Szak) if 
			felvett(Szak,_,_) and not(felvett(_,Szak,_)).

        	alszakok(Szak,[Alszak|Tobbi])	if 
        		felvett(Szak,Alszak,_) and
        		not(mar_regisztralt_alszak(Alszak)) and 
        		assert(mar_regisztralt_alszak(Alszak)) and
        		alszakok(Szak,Tobbi).
        	alszakok(_,[]) if !.
        	
        	eleme(_,[]) if fail.
        	eleme(Elem,[Elem|_]) if !.
        	eleme(Elem,[_|Tobbi]) if eleme(Elem,Tobbi).
        	
        	metszet([],_,[]) .
        	metszet([Elem|Tobbi],Lista,[Elem|Metszet]) if
        		eleme(Elem,Lista) and metszet(Tobbi,Lista,Metszet) and !.
        	metszet([_|Tobbi],Lista,Metszet) if
        		metszet(Tobbi,Lista,Metszet).
        		
        	azonos(Szakok1,Szakok2) if
        		/*amennyiben feltetelezhetjuk, hogy 
        		  nevsorban vannak az alszakok:
        		  Szakok1=Szakok2*/
        		/*amennyiben nem*/
        		  metszet(Szakok1,Szakok2,Metszet1) and Metszet1=Szakok1 and
        		  metszet(Szakok2,Szakok1,Metszet2) and Metszet2=Szakok2.  
        		  
        	azonosalszakok(Szak1,Szak2) if
        		retractall(mar_regisztralt_alszak(_)) and
        		alszakok(Szak1,Alszakok1) and
        		retractall(mar_regisztralt_alszak(_)) and
        		alszakok(Szak2,Alszakok2) and ! and 
        		azonos(Alszakok1,Alszakok2).
        		
        	joszakok(Szak1,Szak2) if
			csakfoszak(Szak1) and csakfoszak(Szak2) and
			Szak1<>Szak2 and azonosalszakok(Szak1,Szak2).

		bfeladat if
			nl and write("B feladat:") and nl and 
			joszakok(Szak1,Szak2) and 
			write(Szak1," ",Szak2) or
			write("Nincs ket ilyen szak!").
			
	/*a c feladathoz szukseges szabalyok*/

		foszak_letszam(Szak,Db) if
			felvett(Szak,Alszak,Db_aktualis) and 
			not(mar_szamolt_letszam(Szak,Alszak)) and
			assert(mar_szamolt_letszam(Szak,Alszak)) and
			foszak_letszam(Szak,Db_maradek) and
			Db=Db_maradek+Db_aktualis or
			Db=0.
		alszak_letszam(Szak,Db) if
			felvett(FoSzak,Szak,Db_aktualis) and 
			not(mar_szamolt_letszam(FoSzak,Szak)) and
			assert(mar_szamolt_letszam(FoSzak,Szak)) and
			alszak_letszam(Szak,Db_maradek) and
			Db=Db_maradek+Db_aktualis or
			Db=0.		
		letszam(Szak,Db) if 
			retractall(mar_szamolt_letszam(_,_)) and
			foszak_letszam(Szak,Dbfo) and
			retractall(mar_szamolt_letszam(_,_)) and
			alszak_letszam(Szak,Dbal) and
			Db=Dbfo+Dbal and !.
		letszamok if 
			szak(Szak) and letszam(Szak,Db) and
			write(Szak,":",Db, " ember") and nl 
			and fail or true.
		cfeladat if 
			nl and write("C feladat:") and nl and letszamok. 
			
			
	/*a d feladathoz szukseges szabalyok*/
        	szakpar(Szak1,Szak2) if 
        		felvett(Szak1,Szak2,_) or felvett(Szak2,Szak1,_).

        	szakparok(Szak,[Szakpar|Tobbi])	if 
        		szakpar(Szak,Szakpar) and
        		not(mar_regisztralt_szakpar(Szakpar)) and 
        		assert(mar_regisztralt_szakpar(Szakpar)) and
        		szakparok(Szak,Tobbi).
        	szakparok(_,[])	if !.

		kiirlista([]) if !.
		kiirlista([Elso|Tobbi]) if write(Elso, " ") and kiirlista(Tobbi).
	
		dfeladat if
			nl and write("D feladat:") and nl and
			write("Szak: ") and readln(Szak) and
			szak(Szak) and
			retractall(mar_regisztralt_szakpar(_)) and 
			szakparok(Szak,Szakparok) and 
			kiirlista(Szakparok) or
			write("Ilyen szak nincs!").			

goal
	clearwindow and
	write("Tanar szakok") and
	letezoszakok and
	afeladat_mo1 and afeladat_mo2 and bfeladat and cfeladat and dfeladat.