/* 
Europa terkeperol a kovetkezo alaku tenyeket vesszuk fel: 
 szomszedja(orszagnev,orszagnev),
 szinez(orszagnev,szin)

a/  Van-e olyan orszag, amelynek 2 azonos szinu szomszedja van?
b/  Mely orszagokon keresztul lehet eljutni egyik orszagbol egy masikba?
c/  Melyik orszagnak van a legtobb szomszedja?
d/  Melyik az az orszag, akinek a legtobb szinu szomszedja van?
*/

domains
   orszagnev=string
   szin=string

database
   marvolt(szin)
   marjartitt(orszagnev)

predicates
   szomszedja(orszagnev,orszagnev)
   szinez(orszagnev,szin)
   hataros(orszagnev,orszagnev)

   /*  a/  */
   azonosszinu(orszagnev)   /*szomszedok azonos szinuek*/
   vane  
   
   /*  b/  */
   orszagok
   hogyjutodafo(orszagnev,orszagnev)
   hogyjutoda(orszagnev,orszagnev)
   
   /*  c/  */
   szomszedszamfo(orszagnev,integer)
   szomszedszam(orszagnev,integer)
   nemlegtobbszomszed(orszagnev)
   legtobbszomszed(orszagnev) 
   
   /*  d/  */
   szinszamfo(orszagnev,integer)
   szinszam(orszagnev,integer)  
   nemlegtobbszinu(orszagnev)
   legtobbszinu(orszagnev)
   legtszin(orszagnev)

clauses
   szomszedja("Magyar","Cseh").
   szomszedja("Magyar","Roman").
   szomszedja("Magyar","Ukran").
   szomszedja("Magyar","Ausztria").
   szomszedja("Ausztria","Svajc").
   szomszedja("Ausztria","Olasz").
   szomszedja("Ausztria", "Szlovenia").
   szomszedja("Svajc","Nemet").
   szomszedja("Svajc","Francia").
   szomszedja("Anglia","tenger").    
   /*Legyen olyan orszag is, ahova nem lehet eljutni*/
   
   szinez("Magyar",barna).
   szinez("Cseh",sarga).
   szinez("Ukran",feher).
   szinez("Roman",zold).
   szinez("Svajc",piros).
   szinez("Ausztria",lila).
   szinez("Szlovenia",sarga).
   szinez("Francia",kek).
   szinez("Olasz",zold).   
   szinez("Anglia",kek).
   szinez("Nemet",kek).
   
   hataros(Orszag1,Orszag2) if 
   	szomszedja(Orszag1,Orszag2) or szomszedja(Orszag2,Orszag1).

   azonosszinu(Orszag) if 
   	hataros(Orszag,O2) and hataros(Orszag,O3) and O2<>O3 and 
        szinez(O2,Szin2) and szinez(O3,Szin3) and Szin2=Szin3.    

   vane if 
   	azonosszinu(Orszag) and 
        write("Van olyan orszag, amelynek van azonos szinu szomszedja") and nl 
        or
        write("Nincs azonos szinu szomszedokkal rendelkezo orszag").
   
   orszagok if szinez(Orszag,_) and write(Orszag,", ") and nl and fail or !.
   
   hogyjutodafo(Orsz1,_) if 
           not(szinez(Orsz1,_)) and 
           write("Az elso orszag nevet elhibazta!").
   hogyjutodafo(_,Orsz2) if 
           not(szinez(Orsz2,_)) and
           write("A masodik orszag nevet elhibazta!").
   
   hogyjutodafo(Orsz1,Orsz2) if 
           szinez(Orsz1,_) and szinez(Orsz2,_) and 
           retractall(marjartitt(_)) and 
           assert(marjartitt(Orsz1)) and hogyjutoda(Orsz1,Orsz2) 
           and write(Orsz1) and nl or 
           write("Nem lehet eljutni").
           
   hogyjutoda(Orsz1,Orsz2) if 
           hataros(Orsz1,Orsz2) and assert(marjartitt(Orsz2)) and 
           write(Orsz2) and nl.
           
   hogyjutoda(Orsz1,Orsz2) if 
           hataros(Orsz1,Orsz3) and 
           not(marjartitt(Orsz3)) and assert(marjartitt(Orsz3)) and 
           hogyjutoda(Orsz3,Orsz2) and 
           write(Orsz3) and nl.

 /*   c/  */
   szomszedszamfo(Orsz,Db) if 
   	retractall(marjartitt(_)) and szomszedszam(Orsz,Db). 
   	
   szomszedszam(Orsz,Db) if 
   	hataros(Orsz,O2) and 
   	not(marjartitt(O2)) and assert(marjartitt(O2)) and ! and
   	szomszedszam(Orsz,Db2) and Db=Db2+1 
   	or Db=0.
   	
   nemlegtobbszomszed(Orsz) if 
   	hataros(Orsz,_) and hataros(O2,_) and Orsz<>O2
        and szomszedszamfo(Orsz,Db) and szomszedszamfo(O2,Db2) and Db<=Db2.
                   
   legtobbszomszed(Orsz) if  
   	not(nemlegtobbszomszed(Orsz)) and 
   	write("A legtobb szomszedja:", Orsz,"-nak van")
        or write("Tobb orszagnak van u.annyi szomszedja").

/*   d/  */
   szinszamfo(Orsz,Db) if 
   	retractall(marvolt(_)) and szinszam(Orsz,Db).
   	
   szinszam(Orsz,Db) if 
   	hataros(Orsz,Szomsz) and szinez(Szomsz,Szin) and 
        not(marvolt(Szin))  and assert(marvolt(Szin)) and ! and
        szinszam(Orsz,Db2) and Db=Db2+1 or Db=0.
   
   nemlegtobbszinu(Orsz) if 
   	hataros(Orsz,_) and hataros(O2,_) and Orsz<>O2 and 
        szinszamfo(Orsz,Db) and szinszamfo(O2,Db2)and Db<=Db2.

   legtobbszinu(Orsz) if 
   	hataros(Orsz,_) and not(nemlegtobbszinu(Orsz)) and !.
   
   legtszin(Orsz) if 
        legtobbszinu(Orsz) and 
        write("A legtobb szinu szomszedos orszaggal ",Orsz," rendelkezik.") and nl 
        or write("Tobb orszagnak is van u.annyi szinu szomszedja, nincs legtobb...").    

goal

   makewindow(1,2,4,"Terkepes",0,0,24,79) and 
   clearwindow and nl and nl and 
   /* a/ */ vane and nl and
   /* c/, d/ */ 
     szinez(Orszag,_) and 
     legtobbszomszed(Orszag) and  nl and
     legtszin(Orszag) and nl and
   /* b/ */
     write("Megadja, hogy hogyan jutunk el egyik orszagbol a masikba") and nl and
     write("Orszagok:") and nl and orszagok and nl and  
     write("Egyik orszag:") and readln(Egyik) and 
     write("Masik orszag:") and readln(Masik) and 
     hogyjutodafo(Egyik,Masik) and nl.   